## containerd 1.5.2

=== debian/changelog ===
containerd (1.5.2-0ubuntu1~20.10.2) groovy-security; urgency=medium

  * SECURITY UPDATE: unexpected host file permission changes
    - debian/patches/1.5-Cleanup-lchmod-logic-in-archive.patch: cleanup
      lchmod logic in archive in archive/tar.go, archive/tar_freebsd.go,
      archive/tar_mostunix.go, archive/tar_test.go, archive/tar_unix.go,
      archive/tar_windows.go.
    - No CVE number yet

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Tue, 13 Jul 2021 12:55:12 -0400

containerd (1.5.2-0ubuntu1~20.10.1) groovy; urgency=medium

  * New upstream release, backport from Impish (LP: #1931464).
  * d/p/skip-tests-with-privilege.patch: add a patch to skip tests which
    require a certain level of privilege not achievable in the build
    environment.

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Fri, 21 May 2021 17:02:23 -0300

containerd (1.4.4-0ubuntu1~20.10.1) groovy; urgency=medium

  * Backport version 1.4.4-0ubuntu1 from Hirsute (LP: #1919322).
    - d/control: update Breaks docker.io version to match version in Groovy.

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Tue, 16 Mar 2021 18:26:07 -0300

=== debian/control ===
Source: containerd
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
Uploaders: Tianon Gravi <tianon@debian.org>
Build-Depends: debhelper (>= 9),
               dh-golang,
               go-md2man,
               golang-go,
               libbtrfs-dev | btrfs-progs (<< 4.16.1~),
               libseccomp-dev,
               pkg-config
Standards-Version: 3.9.7
Homepage: https://containerd.io
Vcs-Git: https://github.com/tianon/debian-containerd.git -b ubuntu
Vcs-Browser: https://github.com/tianon/debian-containerd/tree/ubuntu
XS-Go-Import-Path: github.com/containerd/containerd

Package: containerd
Architecture: linux-any
Depends: runc (>= 1.0.0~rc2~), ${misc:Depends}, ${shlibs:Depends}
Breaks: docker.io (<< 19.03.13-0ubuntu3.1)
Built-Using: ${misc:Built-Using}
Description: daemon to control runC
 Containerd is a daemon to control runC, built for performance and density.
 Containerd leverages runC's advanced features such as seccomp and user
 namespace support as well as checkpoint and restore for cloning and live
 migration of containers.
 .
 This package contains the binaries.

Package: golang-github-containerd-containerd-dev
Architecture: all
Depends: ${misc:Depends}
Description: runC develpoment files
 Containerd is a daemon to control runC, built for performance and density.
 Containerd leverages runC's advanced features such as seccomp and user
 namespace support as well as checkpoint and restore for cloning and live
 migration of containers.
 .
 This package provides development files.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

# temporary build path (see http://golang.org/doc/code.html#GOPATH)
OUR_GOPATH := $(CURDIR)/.gopath
export GOPATH := $(OUR_GOPATH)
export GOCACHE := $(CURDIR)/.gocache

# https://blog.golang.org/go116-module-changes (TODO figure out a new solution for Go 1.17+)
export GO111MODULE := auto

# riscv64 doesn't support cgo
# https://github.com/golang/go/issues/36641
ifeq (riscv64, $(DEB_BUILD_ARCH))
TAGS += no_btrfs
SKIP += github.com/containerd/containerd/snapshots/btrfs
endif

# build explicitly against Go 1.13 (for now):
#   https://github.com/containerd/containerd/issues/4509
#   https://github.com/containerd/containerd/pull/4050
#   https://github.com/golang/go/issues/37942
# (containerd 1.4+ and Go 1.15+ can go back to "golang-go")
export PATH := /usr/lib/go-1.13/bin:$(PATH)

override_dh_gencontrol:
	# use "dh_golang" to generate "misc:Built-Using" (via "go list")
	DH_GOLANG_BUILDPKG=' \
		-tags "$(TAGS)" \
		github.com/containerd/containerd/cmd/containerd \
		github.com/containerd/containerd/cmd/containerd-shim \
		github.com/containerd/containerd/cmd/containerd-shim-runc-v1 \
		github.com/containerd/containerd/cmd/containerd-shim-runc-v2 \
		github.com/containerd/containerd/cmd/containerd-stress \
		github.com/containerd/containerd/cmd/ctr \
	' dh_golang --builddirectory='$(OUR_GOPATH:$(CURDIR)/%=%)'
	dh_gencontrol

override_dh_auto_configure:
	# copy pristine source for "/usr/share/gocode" to get into "golang-github-containerd-containerd-dev" before we muddy it with build artifacts, etc
	mkdir -p .pristine-source
	tar -c --exclude=debian --exclude=.pc --exclude=.pristine-source --exclude=vendor . | tar -xC .pristine-source
	# set up GOPATH symlink farm
	mkdir -p '$(OUR_GOPATH)/src/github.com/containerd'
	ln -sfT '$(CURDIR)' '$(OUR_GOPATH)/src/github.com/containerd/containerd'

override_dh_auto_build:
	cd '$(OUR_GOPATH)/src/github.com/containerd/containerd' \
		&& make \
			LDFLAGS='' \
			VERSION='$(shell dpkg-parsechangelog -SVersion)' \
			REVISION='' \
			BUILDTAGS='$(TAGS)' \
		&& make man

override_dh_auto_test:
ifneq (arm, $(DEB_HOST_ARCH_CPU)) # skip the tests on armhf ("--- FAIL: TestParseSelector/linux (0.00s)  platforms_test.go:292: arm support not fully implemented: not implemented")
	cd '$(OUR_GOPATH)/src/github.com/containerd/containerd' && make test SKIPTESTS='$(SKIP)'
endif

override_dh_auto_install:
	make install DESTDIR='$(CURDIR)/debian/tmp/usr'
	make install-man DESTDIR='$(CURDIR)/debian/tmp/usr/share'
	mkdir -p debian/tmp/usr/share/gocode/src/github.com/containerd \
		&& mv .pristine-source debian/tmp/usr/share/gocode/src/github.com/containerd/containerd

override_dh_installinit:
	dh_installinit
	# replace "/usr/local/bin/containerd" with "/usr/bin/containerd" in our systemd service file
	grep '/usr/local/bin/containerd' debian/*/lib/systemd/system/containerd.service \
		&& sed -i 's!/usr/local/bin/containerd!/usr/bin/containerd!g' debian/*/lib/systemd/system/containerd.service \
		&& ! grep '/usr/local/bin/containerd' debian/*/lib/systemd/system/containerd.service

%:
	dh $@ --with=systemd

## containerd 1.5.5~ds1

=== debian/changelog ===
containerd (1.5.5~ds1-1) unstable; urgency=medium

  * Upload to unstable
  * New upstream version 1.5.5~ds1

 -- Shengjing Zhu <zhsj@debian.org>  Mon, 23 Aug 2021 23:48:51 +0800

containerd (1.5.4~ds1-1) experimental; urgency=medium

  * New upstream version 1.5.4~ds1
    Fix CVE-2021-32760.

 -- Shengjing Zhu <zhsj@debian.org>  Tue, 20 Jul 2021 02:45:17 +0800

containerd (1.5.3~ds1-1) experimental; urgency=medium

  * New upstream version 1.5.3~ds1

 -- Shengjing Zhu <zhsj@debian.org>  Wed, 14 Jul 2021 23:34:39 +0800

containerd (1.5.2~ds1-1) experimental; urgency=medium

  * New upstream version 1.5.2~ds1

 -- Shengjing Zhu <zhsj@debian.org>  Thu, 17 Jun 2021 00:28:02 +0800

containerd (1.5.0~rc1~ds1-1) experimental; urgency=medium

  * New upstream version 1.5.0~rc1~ds1

 -- Shengjing Zhu <zhsj@debian.org>  Wed, 14 Apr 2021 00:20:38 +0800

containerd (1.5.0~rc0~ds1-1) experimental; urgency=medium

  * New upstream version 1.5.0~rc0~ds1

 -- Shengjing Zhu <zhsj@debian.org>  Sat, 10 Apr 2021 00:17:58 +0800

containerd (1.5.0~beta4~ds1-1) experimental; urgency=medium

  * New upstream version 1.5.0~beta4~ds1

 -- Shengjing Zhu <zhsj@debian.org>  Wed, 17 Mar 2021 02:57:58 +0800

containerd (1.5.0~beta3~ds1-1) experimental; urgency=medium

  * New upstream version 1.5.0~beta3~ds1

 -- Shengjing Zhu <zhsj@debian.org>  Fri, 05 Mar 2021 19:27:36 +0800

containerd (1.5.0~beta2~ds1-1) experimental; urgency=medium

  * New upstream version 1.5.0~beta2~ds1
  * Drop github.com/syndtr/gocapability from Depends

 -- Shengjing Zhu <zhsj@debian.org>  Sat, 27 Feb 2021 01:31:44 +0800

containerd (1.5.0~beta1~ds1-2) experimental; urgency=medium

  * Run integration test in autopkgtest

 -- Shengjing Zhu <zhsj@debian.org>  Sat, 06 Feb 2021 19:48:47 +0800

containerd (1.5.0~beta1~ds1-1) experimental; urgency=medium

  * New upstream version 1.5.0~beta1~ds1

 -- Shengjing Zhu <zhsj@debian.org>  Sat, 06 Feb 2021 17:37:26 +0800

containerd (1.5.0~beta0~ds1-1) experimental; urgency=medium

  * New upstream version 1.5.0~beta0~ds1

 -- Shengjing Zhu <zhsj@debian.org>  Sat, 23 Jan 2021 20:42:28 +0800

=== debian/control ===
Source: containerd
Section: admin
Priority: optional
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders: Tianon Gravi <tianon@debian.org>,
           Tim Potter <tpot@hpe.com>,
           Shengjing Zhu <zhsj@debian.org>,
Build-Depends: debhelper-compat (= 13),
               dh-golang,
               go-md2man,
               golang-any,
               golang-github-containerd-btrfs-dev (>= 0.0~git20200117.1539353~),
               golang-github-containerd-cgroups-dev (>= 0.0~git20200817.7a3c009~),
               golang-github-containerd-console-dev,
               golang-github-containerd-continuity-dev (>= 0.0~git20190827.75bee3e~),
               golang-github-containerd-fifo-dev (>= 1.0.0~),
               golang-github-containerd-go-cni-dev (>= 1.0.2~),
               golang-github-containerd-go-runc-dev (>= 0.0~git20190226.7d11b49~),
               golang-github-containerd-ttrpc-dev (>= 0.0~git20190828.92c8520~),
               golang-github-containerd-typeurl-dev,
               golang-github-containernetworking-plugins-dev,
               golang-github-containers-ocicrypt-dev,
               golang-github-coreos-bbolt-dev,
               golang-github-coreos-go-systemd-dev,
               golang-github-davecgh-go-spew-dev,
               golang-github-docker-go-events-dev,
               golang-github-docker-go-metrics-dev,
               golang-github-docker-go-units-dev,
               golang-github-docker-spdystream-dev,
               golang-github-emicklei-go-restful-dev,
               golang-github-fsnotify-fsnotify-dev,
               golang-github-go-logr-logr-dev,
               golang-github-gogo-googleapis-dev (>= 1.4.0~),
               golang-github-gogo-protobuf-dev (>= 1.3.0~),
               golang-github-google-go-cmp-dev,
               golang-github-google-gofuzz-dev,
               golang-github-google-uuid-dev,
               golang-github-gotestyourself-gotest.tools-dev (>= 3.0.0~),
               golang-github-grpc-ecosystem-go-grpc-prometheus-dev,
               golang-github-hashicorp-go-multierror-dev,
               golang-github-imdario-mergo-dev,
               golang-github-klauspost-compress-dev,
               golang-github-moby-locker-dev,
               golang-github-opencontainers-go-digest-dev (>= 1.0.0~),
               golang-github-opencontainers-image-spec-dev,
               golang-github-opencontainers-runc-dev (>= 0.1.0~),
               golang-github-opencontainers-runtime-spec-dev,
               golang-github-opencontainers-selinux-dev,
               golang-github-pelletier-go-toml-dev,
               golang-github-pkg-errors-dev,
               golang-github-prometheus-client-golang-dev,
               golang-github-sirupsen-logrus-dev,
               golang-github-tchap-go-patricia-dev,
               golang-github-urfave-cli-dev (>= 1.22.2-4~),
               golang-go-zfs-dev,
               golang-golang-x-net-dev,
               golang-golang-x-sync-dev,
               golang-golang-x-sys-dev,
               golang-google-grpc-dev,
               golang-gopkg-inf.v0-dev,
               golang-k8s-sigs-structured-merge-diff-dev,
               golang-k8s-sigs-yaml-dev,
Standards-Version: 4.5.1
Rules-Requires-Root: no
Homepage: https://containerd.io/
Vcs-Git: https://salsa.debian.org/go-team/packages/containerd.git
Vcs-Browser: https://salsa.debian.org/go-team/packages/containerd
XS-Go-Import-Path: github.com/containerd/containerd
Testsuite: autopkgtest-pkg-go

Package: containerd
Architecture: linux-any
Breaks: docker.io (<< 1.12),
Depends: runc (>= 0.1.0~),
         ${misc:Depends},
         ${shlibs:Depends},
Suggests: containernetworking-plugins,
Built-Using: ${misc:Built-Using},
Description: open and reliable container runtime
 Containerd is an industry-standard container runtime with an emphasis on
 simplicity, robustness and portability. It is available as a daemon for
 Linux and Windows, which can manage the complete container life cycle of
 its host system: image transfer and storage, container execution and
 supervision, low-level storage and network attachments, etc.
 .
 Containerd is designed to be embedded into a larger system, rather than
 being used directly by developers or end-users.
 .
 This package contains the binaries.

Package: golang-github-containerd-containerd-dev
Architecture: all
Section: golang
Depends: golang-github-containerd-btrfs-dev (>= 0.0~git20200117.1539353~),
         golang-github-containerd-cgroups-dev (>= 0.0~git20200817.7a3c009~),
         golang-github-containerd-console-dev,
         golang-github-containerd-continuity-dev (>= 0.0~git20190827.75bee3e~),
         golang-github-containerd-fifo-dev (>= 1.0.0~),
         golang-github-containerd-go-cni-dev (>= 1.0.2~),
         golang-github-containerd-go-runc-dev (>= 0.0~git20190226.7d11b49~),
         golang-github-containerd-ttrpc-dev (>= 0.0~git20190828.92c8520~),
         golang-github-containerd-typeurl-dev,
         golang-github-containernetworking-plugins-dev,
         golang-github-coreos-bbolt-dev,
         golang-github-coreos-go-systemd-dev,
         golang-github-docker-go-events-dev,
         golang-github-docker-go-metrics-dev,
         golang-github-docker-go-units-dev,
         golang-github-gogo-googleapis-dev (>= 1.4.0~),
         golang-github-gogo-protobuf-dev (>= 1.3.0~),
         golang-github-google-uuid-dev,
         golang-github-grpc-ecosystem-go-grpc-prometheus-dev,
         golang-github-hashicorp-go-multierror-dev,
         golang-github-imdario-mergo-dev,
         golang-github-klauspost-compress-dev,
         golang-github-moby-locker-dev,
         golang-github-opencontainers-go-digest-dev (>= 1.0.0~),
         golang-github-opencontainers-image-spec-dev,
         golang-github-opencontainers-runc-dev (>= 0.1.0~),
         golang-github-opencontainers-runtime-spec-dev,
         golang-github-opencontainers-selinux-dev,
         golang-github-pelletier-go-toml-dev,
         golang-github-pkg-errors-dev,
         golang-github-prometheus-client-golang-dev,
         golang-github-sirupsen-logrus-dev,
         golang-github-urfave-cli-dev (>= 1.22.2~),
         golang-go-zfs-dev,
         golang-golang-x-net-dev,
         golang-golang-x-sync-dev,
         golang-golang-x-sys-dev,
         golang-google-grpc-dev,
         ${misc:Depends},
Description: open and reliable container runtime (development files)
 Containerd is an industry-standard container runtime with an emphasis on
 simplicity, robustness and portability. It is available as a daemon for
 Linux and Windows, which can manage the complete container life cycle of
 its host system: image transfer and storage, container execution and
 supervision, low-level storage and network attachments, etc.
 .
 Containerd is designed to be embedded into a larger system, rather than
 being used directly by developers or end-users.
 .
 This package provides development files.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

PKG        := github.com/containerd/containerd
GO_LDFLAGS += -X $(PKG)/version.Version=$(DEB_VERSION_UPSTREAM)
GO_LDFLAGS += -X $(PKG)/version.Revision=$(DEB_VERSION)
EXCLUDES   += cmd/protoc-gen-gogoctrd cmd/containerd-stress
EXCLUDES   += runtime/v2/example/cmd
EXCLUDES   += integration
CRI_FILE   += cmd/containerd/builtins_cri.go pkg/cri
CRI_FILE   += vendor/k8s.io
CRI_FILE   += vendor/github.com/containerd/imgcrypt
CRI_FILE   += vendor/github.com/containerd/nri

export DH_GOLANG_EXCLUDES      := $(EXCLUDES)

%:
	dh $@ --buildsystem=golang --with=golang --builddirectory=_build

override_dh_auto_build:
	dh_auto_build -- -ldflags '$(GO_LDFLAGS)'

execute_after_dh_auto_build:
	mkdir -p man
	make man/containerd-config.8
	make man/containerd-config.toml.5
	_build/bin/gen-manpages containerd.8 man
	_build/bin/gen-manpages ctr.8 man
	rm -vf _build/bin/gen-manpages

	sed 's|/usr/local/bin|/usr/bin|' containerd.service > debian/containerd.service
	mkdir -vp debian/bash-completion
	install -m644 -T /usr/share/gocode/src/github.com/urfave/cli/autocomplete/bash_autocomplete \
		debian/bash-completion/ctr
	mkdir -vp debian/zsh-completion
	sed 's|$$PROG|ctr|g' /usr/share/gocode/src/github.com/urfave/cli/autocomplete/zsh_autocomplete > \
		debian/zsh-completion/_ctr

override_dh_auto_test:
	# pkg/cri/server tests needs permission in schroot
	DH_GOLANG_EXCLUDES="$(EXCLUDES) pkg/cri/server" dh_auto_test

override_dh_auto_install:
	DH_GOLANG_EXCLUDES="$(EXCLUDES) $(CRI_FILE)" dh_auto_install

## containerd 1.5.5

=== debian/changelog ===
containerd (1.5.5-0ubuntu3~21.04.1) hirsute; urgency=medium

  * Backport version 1.5.5-0ubuntu3 from Impish (LP: #1938908).

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Fri, 08 Oct 2021 11:37:00 -0300

containerd (1.5.5-0ubuntu3) impish; urgency=medium

  * SECURITY UPDATE: insufficiently restricted directory permissions
    - debian/patches/1.5-reduce-directory-permissions.patch: reduce
      permissions for bundle dir in runtime/v1/linux/bundle.go,
      runtime/v1/linux/bundle_test.go, runtime/v2/bundle.go,
      runtime/v2/bundle_default.go, runtime/v2/bundle_linux.go,
      runtime/v2/bundle_linux_test.go, runtime/v2/bundle_test.go,
      snapshots/btrfs/btrfs.go.
    - CVE-2021-41103

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 06 Oct 2021 09:13:26 -0400

containerd (1.5.5-0ubuntu2) impish; urgency=medium

  * d/p/seccomp-support-clone3-syscall.patch: clone3 is explicitly requested
    to give ENOSYS instead of the default EPERM, when CAP_SYS_ADMIN is unset.
    (LP: #1943049).

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Tue, 14 Sep 2021 11:45:36 -0300

containerd (1.5.5-0ubuntu1) impish; urgency=medium

  * New upstream release.
  * Bump debhelper compatibility level to 11.
    - d/rules: remove the unneeded --with=systemd from the dh call.
    - d/rules: override dh_installsystemd instead of dh_installinit.

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Wed, 04 Aug 2021 17:37:16 -0300

containerd (1.5.2-0ubuntu1) impish; urgency=medium

  * New upstream release.
  * d/p/skip-tests-with-privilege.patch: add a patch to skip tests which
    require a certain level of privilege not achievable in the build
    environment.

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Thu, 20 May 2021 15:55:04 -0300

## containerd 1.5.8~ds1

=== Makefile ===
#   Copyright The containerd Authors.

#   Licensed under the Apache License, Version 2.0 (the "License");
#   you may not use this file except in compliance with the License.
#   You may obtain a copy of the License at

#       http://www.apache.org/licenses/LICENSE-2.0

#   Unless required by applicable law or agreed to in writing, software
#   distributed under the License is distributed on an "AS IS" BASIS,
#   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#   See the License for the specific language governing permissions and
#   limitations under the License.


# Go command to use for build
GO ?= go

# Root directory of the project (absolute path).
ROOTDIR=$(dir $(abspath $(lastword $(MAKEFILE_LIST))))

# Base path used to install.
DESTDIR ?= /usr/local
TEST_IMAGE_LIST ?=

# Used to populate variables in version package.
VERSION=$(shell git describe --match 'v[0-9]*' --dirty='.m' --always)
REVISION=$(shell git rev-parse HEAD)$(shell if ! git diff --no-ext-diff --quiet --exit-code; then echo .m; fi)
PACKAGE=github.com/containerd/containerd
SHIM_CGO_ENABLED ?= 0

ifneq "$(strip $(shell command -v $(GO) 2>/dev/null))" ""
	GOOS ?= $(shell $(GO) env GOOS)
	GOARCH ?= $(shell $(GO) env GOARCH)
else
	ifeq ($(GOOS),)
		# approximate GOOS for the platform if we don't have Go and GOOS isn't
		# set. We leave GOARCH unset, so that may need to be fixed.
		ifeq ($(OS),Windows_NT)
			GOOS = windows
		else
			UNAME_S := $(shell uname -s)
			ifeq ($(UNAME_S),Linux)
				GOOS = linux
			endif
			ifeq ($(UNAME_S),Darwin)
				GOOS = darwin
			endif
			ifeq ($(UNAME_S),FreeBSD)
				GOOS = freebsd
			endif
		endif
	else
		GOOS ?= $$GOOS
		GOARCH ?= $$GOARCH
	endif
endif

ifndef GODEBUG
	EXTRA_LDFLAGS += -s -w
	DEBUG_GO_GCFLAGS :=
	DEBUG_TAGS :=
else
	DEBUG_GO_GCFLAGS := -gcflags=all="-N -l"
	DEBUG_TAGS := static_build
endif

WHALE = "🇩"
ONI = "👹"

RELEASE=containerd-$(VERSION:v%=%).${GOOS}-${GOARCH}
CRIRELEASE=cri-containerd-$(VERSION:v%=%)-${GOOS}-${GOARCH}
CRICNIRELEASE=cri-containerd-cni-$(VERSION:v%=%)-${GOOS}-${GOARCH}

PKG=github.com/containerd/containerd

# Project binaries.
COMMANDS=ctr containerd containerd-stress
MANPAGES=ctr.8 containerd.8 containerd-config.8 containerd-config.toml.5

ifdef BUILDTAGS
    GO_BUILDTAGS = ${BUILDTAGS}
endif
GO_BUILDTAGS ?=
GO_BUILDTAGS += ${DEBUG_TAGS}
GO_TAGS=$(if $(GO_BUILDTAGS),-tags "$(GO_BUILDTAGS)",)
GO_LDFLAGS=-ldflags '-X $(PKG)/version.Version=$(VERSION) -X $(PKG)/version.Revision=$(REVISION) -X $(PKG)/version.Package=$(PACKAGE) $(EXTRA_LDFLAGS)'
SHIM_GO_LDFLAGS=-ldflags '-X $(PKG)/version.Version=$(VERSION) -X $(PKG)/version.Revision=$(REVISION) -X $(PKG)/version.Package=$(PACKAGE) -extldflags "-static" $(EXTRA_LDFLAGS)'

# Project packages.
PACKAGES=$(shell $(GO) list ${GO_TAGS} ./... | grep -v /vendor/ | grep -v /integration)
TEST_REQUIRES_ROOT_PACKAGES=$(filter \
    ${PACKAGES}, \
    $(shell \
	for f in $$(git grep -l testutil.RequiresRoot | grep -v Makefile); do \
		d="$$(dirname $$f)"; \
		[ "$$d" = "." ] && echo "${PKG}" && continue; \
		echo "${PKG}/$$d"; \
	done | sort -u) \
    )

ifdef SKIPTESTS
    PACKAGES:=$(filter-out ${SKIPTESTS},${PACKAGES})
    TEST_REQUIRES_ROOT_PACKAGES:=$(filter-out ${SKIPTESTS},${TEST_REQUIRES_ROOT_PACKAGES})
endif

#Replaces ":" (*nix), ";" (windows) with newline for easy parsing
GOPATHS=$(shell echo ${GOPATH} | tr ":" "\n" | tr ";" "\n")

TESTFLAGS_RACE=
GO_BUILD_FLAGS=
# See Golang issue re: '-trimpath': https://github.com/golang/go/issues/13809
GO_GCFLAGS=$(shell				\
	set -- ${GOPATHS};			\
	echo "-gcflags=-trimpath=$${1}/src";	\
	)

BINARIES=$(addprefix bin/,$(COMMANDS))

#include platform specific makefile
-include Makefile.$(GOOS)

# Flags passed to `go test`
TESTFLAGS ?= $(TESTFLAGS_RACE) $(EXTRA_TESTFLAGS)
TESTFLAGS_PARALLEL ?= 8

# Use this to replace `go test` with, for instance, `gotestsum`
GOTEST ?= $(GO) test

OUTPUTDIR = $(join $(ROOTDIR), _output)
CRIDIR=$(OUTPUTDIR)/cri

.PHONY: clean all AUTHORS build binaries test integration generate protos checkprotos coverage ci check help install uninstall vendor release mandir install-man genman install-cri-deps cri-release cri-cni-release cri-integration install-deps bin/cri-integration.test
.DEFAULT: default

all: binaries

check: proto-fmt ## run all linters
	@echo "$(WHALE) $@"
	GOGC=75 golangci-lint run

ci: check binaries checkprotos coverage coverage-integration ## to be used by the CI

AUTHORS: .mailmap .git/HEAD
	git log --format='%aN <%aE>' | sort -fu > $@

generate: protos
	@echo "$(WHALE) $@"
	@PATH="${ROOTDIR}/bin:${PATH}" $(GO) generate -x ${PACKAGES}

protos: bin/protoc-gen-gogoctrd ## generate protobuf
	@echo "$(WHALE) $@"
	@PATH="${ROOTDIR}/bin:${PATH}" protobuild --quiet ${PACKAGES}

check-protos: protos ## check if protobufs needs to be generated again
	@echo "$(WHALE) $@"
	@test -z "$$(git status --short | grep ".pb.go" | tee /dev/stderr)" || \
		((git diff | cat) && \
		(echo "$(ONI) please run 'make protos' when making changes to proto files" && false))

check-api-descriptors: protos ## check that protobuf changes aren't present.
	@echo "$(WHALE) $@"
	@test -z "$$(git status --short | grep ".pb.txt" | tee /dev/stderr)" || \
		((git diff $$(find . -name '*.pb.txt') | cat) && \
		(echo "$(ONI) please run 'make protos' when making changes to proto files and check-in the generated descriptor file changes" && false))

proto-fmt: ## check format of proto files
	@echo "$(WHALE) $@"
	@test -z "$$(find . -path ./vendor -prune -o -path ./protobuf/google/rpc -prune -o -name '*.proto' -type f -exec grep -Hn -e "^ " {} \; | tee /dev/stderr)" || \
		(echo "$(ONI) please indent proto files with tabs only" && false)
	@test -z "$$(find . -path ./vendor -prune -o -name '*.proto' -type f -exec grep -Hn "Meta meta = " {} \; | grep -v '(gogoproto.nullable) = false' | tee /dev/stderr)" || \
		(echo "$(ONI) meta fields in proto files must have option (gogoproto.nullable) = false" && false)

build: ## build the go packages
	@echo "$(WHALE) $@"
	@$(GO) build ${DEBUG_GO_GCFLAGS} ${GO_GCFLAGS} ${GO_BUILD_FLAGS} ${EXTRA_FLAGS} ${GO_LDFLAGS} ${PACKAGES}

test: ## run tests, except integration tests and tests that require root
	@echo "$(WHALE) $@"
	@$(GOTEST) ${TESTFLAGS} ${PACKAGES}

root-test: ## run tests, except integration tests
	@echo "$(WHALE) $@"
	@$(GOTEST) ${TESTFLAGS} ${TEST_REQUIRES_ROOT_PACKAGES} -test.root

integration: ## run integration tests
	@echo "$(WHALE) $@"
	@cd "${ROOTDIR}/integration/client" && $(GO) mod download && $(GOTEST) -v ${TESTFLAGS} -test.root -parallel ${TESTFLAGS_PARALLEL} .

# TODO integrate cri integration bucket with coverage
bin/cri-integration.test:
	@echo "$(WHALE) $@"
	@$(GO) test -c ./integration -o bin/cri-integration.test

cri-integration: binaries bin/cri-integration.test ## run cri integration tests
	@echo "$(WHALE) $@"
	@./script/test/cri-integration.sh
	@rm -rf bin/cri-integration.test

benchmark: ## run benchmarks tests
	@echo "$(WHALE) $@"
	@$(GO) test ${TESTFLAGS} -bench . -run Benchmark -test.root

FORCE:

define BUILD_BINARY
@echo "$(WHALE) $@"
@$(GO) build ${DEBUG_GO_GCFLAGS} ${GO_GCFLAGS} ${GO_BUILD_FLAGS} -o $@ ${GO_LDFLAGS} ${GO_TAGS}  ./$<
endef

# Build a binary from a cmd.
bin/%: cmd/% FORCE
	$(call BUILD_BINARY)

bin/containerd-shim: cmd/containerd-shim FORCE # set !cgo and omit pie for a static shim build: https://github.com/golang/go/issues/17789#issuecomment-258542220
	@echo "$(WHALE) bin/containerd-shim"
	@CGO_ENABLED=${SHIM_CGO_ENABLED} $(GO) build ${GO_BUILD_FLAGS} -o bin/containerd-shim ${SHIM_GO_LDFLAGS} ${GO_TAGS} ./cmd/containerd-shim

bin/containerd-shim-runc-v1: cmd/containerd-shim-runc-v1 FORCE # set !cgo and omit pie for a static shim build: https://github.com/golang/go/issues/17789#issuecomment-258542220
	@echo "$(WHALE) bin/containerd-shim-runc-v1"
	@CGO_ENABLED=${SHIM_CGO_ENABLED} $(GO) build ${GO_BUILD_FLAGS} -o bin/containerd-shim-runc-v1 ${SHIM_GO_LDFLAGS} ${GO_TAGS} ./cmd/containerd-shim-runc-v1

bin/containerd-shim-runc-v2: cmd/containerd-shim-runc-v2 FORCE # set !cgo and omit pie for a static shim build: https://github.com/golang/go/issues/17789#issuecomment-258542220
	@echo "$(WHALE) bin/containerd-shim-runc-v2"
	@CGO_ENABLED=${SHIM_CGO_ENABLED} $(GO) build ${GO_BUILD_FLAGS} -o bin/containerd-shim-runc-v2 ${SHIM_GO_LDFLAGS} ${GO_TAGS} ./cmd/containerd-shim-runc-v2

binaries: $(BINARIES) ## build binaries
	@echo "$(WHALE) $@"

man: mandir $(addprefix man/,$(MANPAGES))
	@echo "$(WHALE) $@"

mandir:
	@mkdir -p man

# Kept for backwards compatibility
genman: man/containerd.8 man/ctr.8

man/containerd.8: FORCE
	@echo "$(WHALE) $@"
	$(GO) run cmd/gen-manpages/main.go $(@F) $(@D)

man/ctr.8: FORCE
	@echo "$(WHALE) $@"
	$(GO) run cmd/gen-manpages/main.go $(@F) $(@D)

man/%: docs/man/%.md FORCE
	@echo "$(WHALE) $@"
	go-md2man -in "$<" -out "$@"

define installmanpage
mkdir -p $(DESTDIR)/man/man$(2);
gzip -c $(1) >$(DESTDIR)/man/man$(2)/$(3).gz;
endef

install-man:
	@echo "$(WHALE) $@"
	$(foreach manpage,$(addprefix man/,$(MANPAGES)), $(call installmanpage,$(manpage),$(subst .,,$(suffix $(manpage))),$(notdir $(manpage))))

releases/$(RELEASE).tar.gz: $(BINARIES)
	@echo "$(WHALE) $@"
	@rm -rf releases/$(RELEASE) releases/$(RELEASE).tar.gz
	@install -d releases/$(RELEASE)/bin
	@install $(BINARIES) releases/$(RELEASE)/bin
	@tar -czf releases/$(RELEASE).tar.gz -C releases/$(RELEASE) bin
	@rm -rf releases/$(RELEASE)

release: releases/$(RELEASE).tar.gz
	@echo "$(WHALE) $@"
	@cd releases && sha256sum $(RELEASE).tar.gz >$(RELEASE).tar.gz.sha256sum

# install of cri deps into release output directory
ifeq ($(GOOS),windows)
install-cri-deps: $(BINARIES)
	mkdir -p $(CRIDIR)
	DESTDIR=$(CRIDIR) script/setup/install-cni-windows
	cp bin/* $(CRIDIR)
else
install-cri-deps: $(BINARIES)
	@rm -rf ${CRIDIR}
	@install -d ${CRIDIR}/usr/local/bin
	@install -D -m 755 bin/* ${CRIDIR}/usr/local/bin
	@install -d ${CRIDIR}/opt/containerd/cluster
	@cp -r contrib/gce ${CRIDIR}/opt/containerd/cluster/
	@install -d ${CRIDIR}/etc/systemd/system
	@install -m 644 containerd.service ${CRIDIR}/etc/systemd/system
	echo "CONTAINERD_VERSION: '$(VERSION:v%=%)'" | tee ${CRIDIR}/opt/containerd/cluster/version

	DESTDIR=$(CRIDIR) script/setup/install-runc
	DESTDIR=$(CRIDIR) script/setup/install-cni
	DESTDIR=$(CRIDIR) script/setup/install-critools
	DESTDIR=$(CRIDIR) script/setup/install-imgcrypt

	@install -d $(CRIDIR)/bin
	@install $(BINARIES) $(CRIDIR)/bin
endif

ifeq ($(GOOS),windows)
releases/$(CRIRELEASE).tar.gz: install-cri-deps
	@echo "$(WHALE) $@"
	@cd $(CRIDIR) && tar -czf ../../releases/$(CRIRELEASE).tar.gz *

releases/$(CRICNIRELEASE).tar.gz: install-cri-deps
	@echo "$(WHALE) $@"
	@cd $(CRIDIR) && tar -czf ../../releases/$(CRICNIRELEASE).tar.gz *
else
releases/$(CRIRELEASE).tar.gz: install-cri-deps
	@echo "$(WHALE) $@"
	@tar -czf releases/$(CRIRELEASE).tar.gz -C $(CRIDIR) etc/crictl.yaml etc/systemd usr opt/containerd

releases/$(CRICNIRELEASE).tar.gz: install-cri-deps
	@echo "$(WHALE) $@"
	@tar -czf releases/$(CRICNIRELEASE).tar.gz -C $(CRIDIR) etc usr opt
endif

cri-release: releases/$(CRIRELEASE).tar.gz
	@echo "$(WHALE) $@"
	@cd releases && sha256sum $(CRIRELEASE).tar.gz >$(CRIRELEASE).tar.gz.sha256sum && ln -sf $(CRIRELEASE).tar.gz cri-containerd.tar.gz

cri-cni-release: releases/$(CRICNIRELEASE).tar.gz
	@echo "$(WHALE) $@"
	@cd releases && sha256sum $(CRICNIRELEASE).tar.gz >$(CRICNIRELEASE).tar.gz.sha256sum && ln -sf $(CRICNIRELEASE).tar.gz cri-cni-containerd.tar.gz

clean: ## clean up binaries
	@echo "$(WHALE) $@"
	@rm -f $(BINARIES)
	@rm -f releases/*.tar.gz*
	@rm -rf $(OUTPUTDIR)
	@rm -rf bin/cri-integration.test

clean-test: ## clean up debris from previously failed tests
	@echo "$(WHALE) $@"
	$(eval containers=$(shell find /run/containerd/runc -mindepth 2 -maxdepth 3  -type d -exec basename {} \;))
	$(shell pidof containerd containerd-shim runc | xargs -r -n 1 kill -9)
	@( for container in $(containers); do \

=== integration/images/volume-ownership/Makefile ===
#   Copyright The containerd Authors.

#   Licensed under the Apache License, Version 2.0 (the "License");
#   you may not use this file except in compliance with the License.
#   You may obtain a copy of the License at

#       http://www.apache.org/licenses/LICENSE-2.0

#   Unless required by applicable law or agreed to in writing, software
#   distributed under the License is distributed on an "AS IS" BASIS,
#   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#   See the License for the specific language governing permissions and
#   limitations under the License.

all: build

PROJ=gcr.io/k8s-cri-containerd
VERSION=2.0
IMAGE=$(PROJ)/volume-ownership:$(VERSION)
PLATFORMS?=linux/amd64,linux/arm64

configure-docker:
	gcloud auth configure-docker

build:
	docker buildx build \
	$(OUTPUT) \
	--platform=${PLATFORMS} \
	--tag $(IMAGE) .

push: OUTPUT=--push
push: configure-docker build

.PHONY: configure-docker build push

=== debian/changelog ===
containerd (1.5.8~ds1-3) unstable; urgency=medium

  * Limit integration test on amd64, arm64, armel, armhf, ppc64el, s390x.
    The image used in integration test is k8s.gcr.io/pause:3.5, which only
    supports these architectures.
  * Add golang-golang-x-time-dev to Build-Depends (Closes: #1002246)

 -- Shengjing Zhu <zhsj@debian.org>  Wed, 22 Dec 2021 01:18:49 +0800

containerd (1.5.8~ds1-2) unstable; urgency=medium

  * Bump golang-github-opencontainers-image-spec-dev to 1.0.2

 -- Shengjing Zhu <zhsj@debian.org>  Sat, 20 Nov 2021 17:26:36 +0800

containerd (1.5.8~ds1-1) unstable; urgency=medium

  * New upstream version 1.5.8~ds1
    + Mitigate CVE-2021-41190

 -- Shengjing Zhu <zhsj@debian.org>  Sat, 20 Nov 2021 02:38:26 +0800

containerd (1.5.7~ds1-2) unstable; urgency=medium

  * Add pkg/cri/annotations to -dev package.

 -- Shengjing Zhu <zhsj@debian.org>  Tue, 09 Nov 2021 00:14:57 +0800

containerd (1.5.7~ds1-1) unstable; urgency=medium

  * New upstream version 1.5.7~ds1
    + CVE-2021-41103: Insufficiently restricted permissions on container
      root and plugin directories
  * Update Standards-Version to 4.6.0 (no changes)

 -- Shengjing Zhu <zhsj@debian.org>  Tue, 05 Oct 2021 18:25:35 +0800

=== debian/control ===
--- 
+++ 
@@ -42,7 +42,7 @@
                golang-github-klauspost-compress-dev,
                golang-github-moby-locker-dev,
                golang-github-opencontainers-go-digest-dev (>= 1.0.0~),
-               golang-github-opencontainers-image-spec-dev,
+               golang-github-opencontainers-image-spec-dev (>= 1.0.2~),
                golang-github-opencontainers-runc-dev (>= 0.1.0~),
                golang-github-opencontainers-runtime-spec-dev,
                golang-github-opencontainers-selinux-dev,
@@ -56,11 +56,12 @@
                golang-golang-x-net-dev,
                golang-golang-x-sync-dev,
                golang-golang-x-sys-dev,
+               golang-golang-x-time-dev,
                golang-google-grpc-dev,
                golang-gopkg-inf.v0-dev,
                golang-k8s-sigs-structured-merge-diff-dev,
                golang-k8s-sigs-yaml-dev,
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Homepage: https://containerd.io/
 Vcs-Git: https://salsa.debian.org/go-team/packages/containerd.git
@@ -115,7 +116,7 @@
          golang-github-klauspost-compress-dev,
          golang-github-moby-locker-dev,
          golang-github-opencontainers-go-digest-dev (>= 1.0.0~),
-         golang-github-opencontainers-image-spec-dev,
+         golang-github-opencontainers-image-spec-dev (>= 1.0.2~),
          golang-github-opencontainers-runc-dev (>= 0.1.0~),
          golang-github-opencontainers-runtime-spec-dev,
          golang-github-opencontainers-selinux-dev,

=== debian/rules ===
--- 
+++ 
@@ -8,7 +8,8 @@
 EXCLUDES   += cmd/protoc-gen-gogoctrd cmd/containerd-stress
 EXCLUDES   += runtime/v2/example/cmd
 EXCLUDES   += integration
-CRI_FILE   += cmd/containerd/builtins_cri.go pkg/cri
+CRI_FILE   += cmd/containerd/builtins_cri.go
+CRI_FILE   += $(filter-out pkg/cri/annotations,$(wildcard pkg/cri/*))
 CRI_FILE   += vendor/k8s.io
 CRI_FILE   += vendor/github.com/containerd/imgcrypt
 CRI_FILE   += vendor/github.com/containerd/nri

=== debian/tests/control ===
Tests: integration
Depends: ca-certificates,
         containerd,
         lsof,
         @builddeps@,
Restrictions: allow-stderr, needs-root, needs-internet, isolation-container, flaky
# Integration test uses k8s.gcr.io/pause:3.5 image
# See the supported architectures for this image:
# $ curl https://k8s.gcr.io/v2/pause/manifests/3.2
Architecture: amd64, arm64, armel, armhf, ppc64el, s390x

## containerd 1.5.9

=== integration/images/volume-copy-up/Makefile ===
#   Copyright The containerd Authors.

#   Licensed under the Apache License, Version 2.0 (the "License");
#   you may not use this file except in compliance with the License.
#   You may obtain a copy of the License at

#       http://www.apache.org/licenses/LICENSE-2.0

#   Unless required by applicable law or agreed to in writing, software
#   distributed under the License is distributed on an "AS IS" BASIS,
#   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#   See the License for the specific language governing permissions and
#   limitations under the License.

all: build

PROJ=gcr.io/k8s-cri-containerd
VERSION=2.0
IMAGE=$(PROJ)/volume-copy-up:$(VERSION)
PLATFORMS?=linux/amd64,linux/arm64

configure-docker:
	gcloud auth configure-docker

build:
	docker buildx build \
	$(OUTPUT) \
	--platform=${PLATFORMS} \
	--tag $(IMAGE) .

push: OUTPUT=--push
push: configure-docker build

.PHONY: configure-docker build push

=== vendor/github.com/containerd/imgcrypt/Makefile ===
#   Copyright The containerd Authors.

#   Licensed under the Apache License, Version 2.0 (the "License");
#   you may not use this file except in compliance with the License.
#   You may obtain a copy of the License at

#       http://www.apache.org/licenses/LICENSE-2.0

#   Unless required by applicable law or agreed to in writing, software
#   distributed under the License is distributed on an "AS IS" BASIS,
#   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#   See the License for the specific language governing permissions and
#   limitations under the License.


# Base path used to install.
DESTDIR ?= /usr/local

COMMANDS=ctd-decoder ctr-enc

BINARIES=$(addprefix bin/,$(COMMANDS))

.PHONY: check build ctd-decoder

all: build

build: $(BINARIES)

FORCE:

bin/ctd-decoder: cmd/ctd-decoder FORCE
	go build -o $@ -v ./cmd/ctd-decoder/

bin/ctr-enc: cmd/ctr FORCE
	go build -o $@ -v ./cmd/ctr/

check:
	@echo "$@"
	@golangci-lint run
	@script/check_format.sh

install:
	@echo "$@"
	@mkdir -p $(DESTDIR)/bin
	@install $(BINARIES) $(DESTDIR)/bin

uninstall:
	@echo "$@"
	@rm -f $(addprefix $(DESTDIR)/bin/,$(notdir $(BINARIES)))

clean:
	@echo "$@"
	@rm -f $(BINARIES)

test:
	@echo "$@"
	@go test ./...

=== debian/changelog ===
containerd (1.5.9-0ubuntu3) jammy; urgency=medium

  * d/p/build-with-go1.18.patch: fix FTBFS with Go 1.18 (LP: #1965157).
    In Go 1.17 the module graph has been changed to enable pruning and lazy
    loading, some changes to go.{mod,sum} files are needed. We were delaying
    the fix of this issue but now is the time.

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Wed, 23 Mar 2022 19:41:42 +0000

containerd (1.5.9-0ubuntu2) jammy; urgency=medium

  * SECURITY UPDATE: Insecure handling of image volumes
    - debian/patches/CVE-2022-23648.patch: Use fs.RootPath when mounting
    volumes.
    - CVE-2022-23648

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Thu, 03 Mar 2022 13:17:25 -0300

containerd (1.5.9-0ubuntu1) jammy; urgency=medium

  * New upstream release (LP: #1946851, #1955413).
  * Remove patches applied by upstream.

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Mon, 10 Jan 2022 16:27:26 -0300

=== debian/control ===
Source: containerd
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
Uploaders: Tianon Gravi <tianon@debian.org>
Build-Depends: debhelper (>= 11),
               dh-golang,
               go-md2man,
               golang-go,
               libbtrfs-dev | btrfs-progs (<< 4.16.1~),
               libseccomp-dev,
               pkg-config
Standards-Version: 3.9.7
Homepage: https://containerd.io
Vcs-Git: https://github.com/tianon/debian-containerd.git -b ubuntu
Vcs-Browser: https://github.com/tianon/debian-containerd/tree/ubuntu
XS-Go-Import-Path: github.com/containerd/containerd

Package: containerd
Architecture: linux-any
Depends: runc (>= 1.0.0~rc2~), ${misc:Depends}, ${shlibs:Depends}
Breaks: docker.io (<< 19.03.13-0ubuntu4)
Built-Using: ${misc:Built-Using}
Description: daemon to control runC
 Containerd is a daemon to control runC, built for performance and density.
 Containerd leverages runC's advanced features such as seccomp and user
 namespace support as well as checkpoint and restore for cloning and live
 migration of containers.
 .
 This package contains the binaries.

Package: golang-github-containerd-containerd-dev
Architecture: all
Depends: ${misc:Depends}
Description: runC develpoment files
 Containerd is a daemon to control runC, built for performance and density.
 Containerd leverages runC's advanced features such as seccomp and user
 namespace support as well as checkpoint and restore for cloning and live
 migration of containers.
 .
 This package provides development files.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

# temporary build path (see http://golang.org/doc/code.html#GOPATH)
OUR_GOPATH := $(CURDIR)/.gopath
export GOPATH := $(OUR_GOPATH)
export GOCACHE := $(CURDIR)/.gocache

# https://blog.golang.org/go116-module-changes (TODO figure out a new solution for Go 1.17+)
export GO111MODULE := auto

# riscv64 doesn't support cgo
# https://github.com/golang/go/issues/36641
ifeq (riscv64, $(DEB_BUILD_ARCH))
TAGS += no_btrfs
SKIP += github.com/containerd/containerd/snapshots/btrfs
endif

# build explicitly against Go 1.13 (for now):
#   https://github.com/containerd/containerd/issues/4509
#   https://github.com/containerd/containerd/pull/4050
#   https://github.com/golang/go/issues/37942
# (containerd 1.4+ and Go 1.15+ can go back to "golang-go")
export PATH := /usr/lib/go-1.13/bin:$(PATH)

override_dh_gencontrol:
	# use "dh_golang" to generate "misc:Built-Using" (via "go list")
	DH_GOLANG_BUILDPKG=' \
		-tags "$(TAGS)" \
		github.com/containerd/containerd/cmd/containerd \
		github.com/containerd/containerd/cmd/containerd-shim \
		github.com/containerd/containerd/cmd/containerd-shim-runc-v1 \
		github.com/containerd/containerd/cmd/containerd-shim-runc-v2 \
		github.com/containerd/containerd/cmd/containerd-stress \
		github.com/containerd/containerd/cmd/ctr \
	' dh_golang --builddirectory='$(OUR_GOPATH:$(CURDIR)/%=%)'
	dh_gencontrol

override_dh_auto_configure:
	# copy pristine source for "/usr/share/gocode" to get into "golang-github-containerd-containerd-dev" before we muddy it with build artifacts, etc
	mkdir -p .pristine-source
	tar -c --exclude=debian --exclude=.pc --exclude=.pristine-source --exclude=vendor . | tar -xC .pristine-source
	# set up GOPATH symlink farm
	mkdir -p '$(OUR_GOPATH)/src/github.com/containerd'
	ln -sfT '$(CURDIR)' '$(OUR_GOPATH)/src/github.com/containerd/containerd'

override_dh_auto_build:
	cd '$(OUR_GOPATH)/src/github.com/containerd/containerd' \
		&& make \
			LDFLAGS='' \
			VERSION='$(shell dpkg-parsechangelog -SVersion)' \
			REVISION='' \
			BUILDTAGS='$(TAGS)' \
		&& make man

override_dh_auto_test:
ifneq (arm, $(DEB_HOST_ARCH_CPU)) # skip the tests on armhf ("--- FAIL: TestParseSelector/linux (0.00s)  platforms_test.go:292: arm support not fully implemented: not implemented")
	cd '$(OUR_GOPATH)/src/github.com/containerd/containerd' && make test SKIPTESTS='$(SKIP)'
endif

override_dh_auto_install:
	make install DESTDIR='$(CURDIR)/debian/tmp/usr'
	make install-man DESTDIR='$(CURDIR)/debian/tmp/usr/share'
	mkdir -p debian/tmp/usr/share/gocode/src/github.com/containerd \
		&& mv .pristine-source debian/tmp/usr/share/gocode/src/github.com/containerd/containerd

override_dh_installsystemd:
	dh_installsystemd
	# replace "/usr/local/bin/containerd" with "/usr/bin/containerd" in our systemd service file
	grep '/usr/local/bin/containerd' debian/*/lib/systemd/system/containerd.service \
		&& sed -i 's!/usr/local/bin/containerd!/usr/bin/containerd!g' debian/*/lib/systemd/system/containerd.service \
		&& ! grep '/usr/local/bin/containerd' debian/*/lib/systemd/system/containerd.service

%:
	dh $@

=== debian/tests/control ===
Tests: basic-smoke
Depends: ca-certificates, @
Restrictions: allow-stderr isolation-machine needs-root

## containerd 1.6.4

=== debian/changelog ===
containerd (1.6.4-0ubuntu1) kinetic; urgency=medium

  * New upstream release.
  * Remove patches applied by upstream:
    - d/p/build-with-go1.18.patch
    - d/p/CVE-2022-23648.patch
  * d/p/build-gen-manpages-instead-of-go-run.patch: add upstream patch to
    avoid calling go run to build manpages.
  * d/rules: fix DESTDIR and PREFIX variables.

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Wed, 11 May 2022 17:48:49 -0300
